/**
 *  渲染新手专享列表其中一个
 * Created by liling on 2016/12/30.
 */


const glpbCommon = require('glpb-components-common');

require('./lp-newer-list-item.scss');

const BaseComponent = glpbCommon.BaseComponent;

const $ = BaseComponent.$;

const utils = BaseComponent.utils;

function LpNewerListItem(args){

    this.source = args.source || '';

    this.$el = null;

}


$.extend( LpNewerListItem.prototype, {

    $getElement : function(){
        return this.$el;
    },

    render : function(){

        let $el = $('<div class="glpb-ui-newer-list-item"></div>');

        this.$el = $el;
    },

    setNewerData : function( data,iconImageUrl,style ){
        let rate = 0,
            time = 0,
            money = 0,
            id = '';

        if( ! data ){
            return;
        }

        if(data.list.length > 0){
            rate = data.list[0].expectedYearRate;
            time = data.list[0].lockPeriod;
            money = data.list[0].singleMaxRegisterAmount;
            id = data.list[0].id;
        }

        let getHost = utils.getTplConf();
        let hostName = getHost.we_renrendai_host;

        let html=  `<div class="new-vip-top"><img src="${iconImageUrl}" alt="icon"></div>
                        <ul class="new-vip-list">
                            <li class="new-vip-info new-vip-left">
                                <div class="number"><span>${rate}</span><i>%</i></div>
                                <div class="text">扣费后年利率 </div>
                            </li>
                            <li class="new-vip-info new-vip-right">
                                <div class="number">期限${time}个月</div>
                                <div class="text">最高可投${money}元</div></li>
                        </ul>
                        <div class="btn-wrap"><a target="_blank" class="j-btn" href="${hostName}/uplan-${id}.html">立即加入</a></div>
            `
        this.$el.html( html ).addClass(style).show();
    },

    destroy(){
        this.$el.off();
        this.$el.remove();
        this.$el = null;
    }
});



module.exports = LpNewerListItem;

