/**
 * LP页面品台优势
 * Created by liling on 2016/12/30
 */


const glpbCommon = require('glpb-components-common');

const DataManager = require('../../common/data-manager/data-manager.js');


require('./lp-register-title.scss');

const BaseComponent = glpbCommon.BaseComponent;

const $ = BaseComponent.$;

const tpl = `<div><div class="glpb-content"></div></div>`;


const LandingPageHeader = BaseComponent.extend(
    {
        componentName : 'glpb_we_com_pc_lp_title',
        componentNameZh : 'PC-LP-标题文本',
        componentCategory : BaseComponent.CATEGORY.UI,
        platform : BaseComponent.PLATFORM.PC,
        canBeChildOfComponentName : function(){
            return true;
        }
    },
    {
        getDefaultStyle : function(){
            return {
                background : {
                    backgroundColor : '#fff'
                },
                height : 'auto',
                width : 'auto',
                padding : '0',
                margin : '0 auto'
            };
        },

        getDefaultData : function(){
            return {
                "titleTxet_$$comment" : 'lp各部分标题文本',
                "titleTxet" : '平台优势',
                "titleFontSize" : '字号',
                "titleFontSize" : '30px',
                "titleLineHeight_$$comment" : '标题行高',
                "titleLineHeight" : '130px',
                "titleColor_$$comment" : '标题颜色',
                "titleColor" : '#2b2b2b'
            };
        },

        init : function(){

            //是否已经绑定了组件自定义事件
            this.eventBinded = false;
        },

        render : function(){
            let currentComponentId = this.componentId;
            let data = this.data;

            let cssClass = this.getBaseCssClass() + '  ';
            let cssStyle = this.translateStyle( this.style );
            let $el = $(tpl).addClass( cssClass ).css( cssStyle );
            let $content = $('.glpb-content', $el);

            this.$el = $el;
            this.$content = $content;
            
            let html = `<h1 style="font-size: ${data.titleFontSize};line-height: ${data.titleLineHeight};color: ${data.titleColor}">${data.titleTxet}</h1>`;

            $content.html( html );
        },

        componentWillUnmount : function(){
            this.$content = null;
        }

    }
);


module.exports = LandingPageHeader;

