/**
 * LP注册框组件
 * Created by 王半仙 on 16/12/27.
 *
 * modify by liucong on 20171127
 * 新增极验
 */


const moment = require('moment');

const numeral = require('numeral');

const glpbCommon = require('glpb-components-common');


const serviceFactory = require('../../service/service-factory.js');

require('./lp-registration-box.scss');

const BaseComponent = glpbCommon.BaseComponent;

const $ = BaseComponent.$;
const eventCenter = glpbCommon.EventEmitter.eventCenter;

const RSAencript = glpbCommon.rsaCrypt;

const RRDValidator = glpbCommon.RRDValidator;

const utils = BaseComponent.utils;

const parameter = glpbCommon.parameter;

const registerService = serviceFactory.getService('register');

const statistic = glpbCommon.weStatistic;

const tpl = __inline('./lp-registration-box.tpl');

const editorPlaceHolderImage = '//www.we.com/cms/5864b3f0c5ee7210913f6796/register/register-box.png';

var $formBox;
var $phone;
var $phoneCode;
var $randCode;
var $countDown;
var $rankCodeWrap;
var $rankCodeShow;
var $mobilePhoneCon;
var $phoneCodeCon;
var $codeImage;
var $password;
var $passwordCon;
var $agree;
var $registerAgreeCon;
var $submitErroInfo;
var $submitBox;

var mess = '';

var SECONDS = 60;
var sendTimes =0;

var timer;
var remainSeconds = 0;

var pageKey;

// 注册接口参数-极验
let __registerOutParamsByGeetest = {};
//注册接口参数-图验
let __registerOutParams = {};

const registerItemList = BaseComponent.extend(
    {
        componentName : 'glpb_we_com_pc_lp_regitstration_box',
        componentNameZh : 'PC-LP注册框',
        componentCategory : BaseComponent.CATEGORY.UI,
        platform : BaseComponent.PLATFORM.PC,
        canBeChildOfComponentName : function(){
            return true;
        }
    },
    {
        getDefaultStyle : function(){
            return {
                background : {
                    backgroundColor : '#fff'
                },
                width : 'auto',
                padding : '0',
                position : 'absolute',
                right: '0',
                top: '66'
            };
        },

        getDefaultData : function(){
            return {
                promotion : '',
                inviteCode : '',
                "type_$$comment" : '来源,默认为空',
                type : '',
                intention : 'LENDER',
                "success_url_$$comment" : '注册成功后跳转的URL，必须是**全地址**,默认为空会根据后端传的地址跳转或者跳转到开户页。如果不需要单独配置跳转，一定**不要配置**',
                success_url : "",
                "submitText_$$comment" : '按钮文本内容',
                submitText : '注册领红包',
                "btnBgColor_$$comment" : '按钮颜色(包括验证码和注册按钮)',
                btnBgColor: '#fa6700',
                "btnTextColor_$$comment" : '按钮文本颜色(包括验证码和注册按钮)',
                btnTextColor: '#fff',
                "hasCallBack_$$comment" : '注册成功后执行回调函数,true执行，false不执行,注:script标签里的函数名**必须**为callBackPbFn',
                hasCallBack: false,
                "__$register_action_hack_url_$$comment" : '!!!!配置注册时要提交的server端action地址，必须由开发同学修改！！！！',
                "__$register_action_hack_url" : ''
            };
        },

        init : function(){
            //当前Ajax请求的ID
            this.querySign = null;
            //是否已经绑定了组件自定义事件
            this.eventBinded = false;
            //交易所列表对应的详细数据
            this.listDetailData = null;

            //风险测评开关
            this.riskSwitchStatus = false;
            //风险测评内容
            this.riskDetail = null;

            //当前发送短信的验证方式
            this.verifyType = 'noNeed';

        },

        render : function(){
            let currentComponentId = this.componentId;
            let data = this.data;
            let cssClass = this.getBaseCssClass() + ' glpb-lp-registration-box';
            let cssStyle = this.translateStyle( this.style );
            cssStyle.height = "350px";
            let $el = $(tpl).addClass( cssClass ).css( cssStyle );
            let $content = $('.glpb-content', $el);

            this.$el = $el;
            this.$boxBg = $el.find('.login-bg-new');

            this.$stepContainer = $content.find('.step-list');
            this.$step1 = this.$stepContainer.find('.step-1');
            this.$step2 = this.$stepContainer.find('.step-2');
            this.renderStep1();

            //初始化极验
            if( window.geetestData && this.isProductionMode() ) {
                this.initGt(geetestData);
                this.initGtParams();
            }

        },

        //初始化极验注册需要
        initGtParams(){
            //先从search中取值，没有就从cookie中取值 add by liucong
            let urlSearchParams = utils.getSearchConf();
            let promotion = urlSearchParams.utm_source || urlSearchParams.utmSource || null;

            if ( promotion == null ){
                promotion =  parameter.getCookie("promotion") || parameter.getCookie("utmSource");
            }

            if ( promotion == null || !promotion.match("[-a-zA-Z0-9?=_/]{1,32}") ) {
                promotion =  parameter.getCookie("promotion_source");
            }else{
                parameter.setCookie("promotion_source", promotion, 365);
            }

            let id = parameter.getId();
            let inviteCode = parameter.getInviteCode();
            let getRegisterSource = parameter.getRegisterSource();

            //将隐藏框中的值 传到页面中去
            this.GtParams = {
                intention : 'LENDER',
                id : id,
                inviteCode : inviteCode,
                registerSource: getRegisterSource,
                utmSource : promotion,
            };
        },

        zhugeFail(mess){
            statistic.eventRaw({
                eventId : 'PC_lp_register_error',
                extra : {
                    '失败原因' : mess
                }
            });
        },

        //将有空格input 值变成手机号
        spaceStrChangeMobile(str){
            str += '';
            //将空格去掉
            str = str.replace(/\ +/g,"");
            return str;
        },

        //手机号中添加空格
        mobileAddSpace(mobile){
            mobile = this.spaceStrChangeMobile(mobile);
            //加上空格
            let one ='', two = '', three = '';
            one = mobile.slice(0,3);
            two = mobile.slice(3,7);
            two = two ? (' ' + two) : two;
            three = mobile.slice(7,11);
            three = three ? (' ' + three) : three;

            mobile = one + two + three;
            return mobile;
        },

        //展示获取验证码按钮的loading
        showGetMessBtnLoading(){
            $countDown.find('.btn-submit-word').hide();
            $countDown.find('.btn-submit-loading').show();
        },

        //隐藏获取验证码按钮的loading
        hideGetMessBtnLoading(){
            $countDown.find('.btn-submit-word').show();
            $countDown.find('.btn-submit-loading').hide();
        },

        //展示注册领红包按钮的loading
        showSubmitBtnLoading(){
            $submitBox.find('.btn-submit-word').hide();
            $submitBox.find('.btn-submit-loading').show();
        },

        //隐藏注册领红包按钮的loading
        hideSubmitBtnLoading(){
            $submitBox.find('.btn-submit-word').show();
            $submitBox.find('.btn-submit-loading').hide();
        },

        //极验注册
        doRegisterByGeetest : function(singleton){

            let success_url = singleton.data.success_url;

            if(!singleton.isPhoneCode()){
                return;
            }
            if(!singleton.isPassWord()){
                return;
            }

            if(!singleton.isAgree()){
                return;
            }

            singleton.showSubmitBtnLoading();

            let password = RSAencript($password.val());
            let formData = {
                username : this.spaceStrChangeMobile($phone.val()),
                password : password,
                mobileCode : $phoneCode.val(),
                agree:"on",
                platform : 'PC',
                channel : window.tplConf._isWeCom == 'false' ? 'RRD' : 'WE'
            }

            //现阶段，url中的utmSource、utm_source并行，但cookie中只存utmSource字段
            let utmSourceInUrl = parameter.getUtmSourceBySearch();
            if(utmSourceInUrl){
                formData.utmSource = utmSourceInUrl;
            }

            //从cookie中获取所有的utm参数
            let utmCookieParams = parameter.getAllUtmCookies();
            //获取url search参数
            let urlSearchParams = utils.getSearchConf();

            //将所有参数合并到formData上
            let finalPostData = $.extend({},singleton.GtParams || {},utmCookieParams,urlSearchParams,formData);

            //删掉可能存在的utm_source字段，只给node端传utmSource
            delete finalPostData.utm_source;

            //传送实际请求的URL
            finalPostData['__$request_action_hack_url'] = singleton.data['__$register_action_hack_url'] || '';

            finalPostData['promotionUrl'] = window.promotionUrl || '';
            finalPostData['forwardingUrl'] = window.forwardingUrl || '';

            //判断是否展示风险测评弹窗
            if(singleton.riskSwitchStatus){
                $('.title','#risk-modal').text(singleton.riskDetail.title || '风险揭示书');
                $('.msg','#risk-modal').html(singleton.riskDetail.body || '');
                __registerOutParamsByGeetest = finalPostData;
                $('.lp-detail-modal-main').show();
                let modal = $('.risk-modal-form','#risk-modal');
                let topOffset = ( $(window).height() - modal.height() ) / 2 + $(window).scrollTop();
                topOffset = topOffset < 0 ? 0 : topOffset;
                modal.css({
                    top: topOffset + 'px'
                });
            }else {
                singleton._submitRigisterByGeetest(finalPostData);
            }

        },

        //普通验证码注册
        doRegisterSubmit : function(singleton){
            let success_url = singleton.data.success_url;

            if( !singleton.isRankCode() ) return;


            if(!singleton.isPhoneCode()){
                return;
            }
            if(!singleton.isPassWord()){
                return;
            }

            if(!singleton.isAgree()){
                return;
            }

            singleton.showSubmitBtnLoading();

            //异步提交表单

            var $form = $("form");

            var serializeData = $form.serialize();

            serializeData = utils.query2json( serializeData );

            //现阶段，url中的utmSource、utm_source并行，但cookie中只存utmSource字段
            let utmSourceInUrl = parameter.getUtmSourceBySearch();
            if(utmSourceInUrl){
                serializeData.utmSource = utmSourceInUrl;
            }

            //从cookie中获取所有的utm参数
            let utmCookieParams = parameter.getAllUtmCookies();

            let queryData = parameter.getQueryData();

            var dataForm=$.extend({},utmCookieParams,serializeData,queryData);

            //删掉可能存在的utm_source字段，只给node端传utmSource
            delete dataForm.utm_source;

            //特殊处理promotion
            if(Object.prototype.hasOwnProperty.call(dataForm,"promotion")){
                dataForm.promotion = dataForm.utmSource || null;
            }

            //需要把密码加密后在发送给后端
            dataForm.password = RSAencript( dataForm.password );
            dataForm.username = dataForm.username.replace(/\D/g, "");

            var mobileNum = dataForm.username;

            //传送实际请求的URL
            dataForm['__$request_action_hack_url'] = singleton.data['__$register_action_hack_url'] || '';

            dataForm['promotionUrl'] = window.promotionUrl || '';
            dataForm['forwardingUrl'] = window.forwardingUrl || '';

            //判断是否展示风险测评弹窗
            if(singleton.riskSwitchStatus){
                //$('.title','#risk-modal').text(singleton.riskDetail.title || '风险揭示书');
                $('.msg','#risk-modal').html(singleton.riskDetail.body || '');
                __registerOutParams = dataForm;
                $('.lp-detail-modal-main').show();
                let modal = $('.risk-modal-form','#risk-modal');
                let topOffset = ( $(window).height() - modal.height() ) / 2 + $(window).scrollTop();
                topOffset = topOffset < 0 ? 0 : topOffset;
                modal.css({
                    top: topOffset + 'px'
                });
            }else {
                singleton._submitRigister(dataForm);
            }

        },

        registerSubmit : function(){
            let singleton = this;

            let success_url = this.data.success_url;

            $(".submit-btn").on("click",function(){
                if( !singleton.isMobile() ){
                    return;

                }

                let callback = null;
                //区分极验和普通验证码的提交接口
                if( singleton.verifyType === 'geetest' ) {
                    singleton.doRegisterByGeetest(singleton);
                }else{
                    singleton.doRegisterSubmit(singleton);
                }


            })

        },

        sendPhoneCode: function(){
            let singleton = this;
            $countDown.on('click', function(){
                if($(this).hasClass('btn-disable')){
                    return;
                }
                singleton.showGetMessBtnLoading();

                if( remainSeconds > 0 ){
                    singleton.hideGetMessBtnLoading();
                    return;
                }

                //发送验证码前验证手机号

                if( !singleton.isMobile() ){
                    singleton.hideGetMessBtnLoading();
                    return;
                }

                singleton.doSendPhoneCode();

            });
        },

        //查询手机号是否存在后的回调
        doSendPhoneCode(){
            let singleton = this;

            //异步发送手机验证码
            let getHost = utils.getTplConf();
            let _isWeCom = getHost._isWeCom;
            let channal = (_isWeCom == 'true') ? 'WE' :'RRD';

            var mobileNum = this.spaceStrChangeMobile($phone.val());
            var randCode = $randCode.val() || "";

            var data = {
                mobile : mobileNum,
                imgCode : randCode,
                channal : channal,
                origin : 'LP-PC'
            };

            registerService.sendRegisterSms( data )
                .then((res)=>{
                    singleton.hideGetMessBtnLoading();
                    if( res.requestStatus === registerService.STATUS.SUCCESS ){
                        if(res.data.status === 3230 || res.data.status === 930002){
                            singleton.verifyType = 'captcha';
                            //显示验证码
                            // singleton.$boxBg.css("height","440px");
                            $rankCodeWrap.show();
                             // 出现图验时，样式调整
                            let outer = $(".glpb-com-glpb_we_com_pc_lp_regitstration_box")
                            $(".glpb-content", outer).css('padding-top', '10px');
                            $(".register-head", outer).css('display', 'none');
                            $(".agreement-wrap", outer).css('margin-top', '0')
                            $(".register-agree", outer).css({
                                'margin-top': '9px',
                                'line-height': '1.5'
                            });
                            //刷新验证码
                            singleton.reloadRandCode();
                        }else if(res.data.status === 1 ){
                            mess = "验证码不正确";
                            singleton.messageTips($rankCodeWrap,mess);
                            singleton.reloadRandCode();
                        }else if( res.data.status === 930001 ){
                            //使用极验
                            // singleton.$boxBg.css("height","420px");
                            $rankCodeWrap.hide();

                            singleton.verifyType = 'geetest';
                            //弹出极验
                            singleton.captchaObj.verify();
                        }else if(res.data.status === 0){
                            $submitErroInfo.text('');
                            $submitBox.css('margin-top', '29px');
                            singleton.resetCountdown();//发送验证码
                            sendTimes++;
                        }else{
                            $submitErroInfo.text(res.data.message);
                            $submitBox.css('margin-top', '10px');
                            singleton.reloadRandCode();
                        }
                        return;
                    }
                    mess = "获取验证码网络异常";
                    singleton.messageTips($rankCodeWrap,mess);
                    singleton.reloadRandCode();
                })
                .catch( (e) => {
                    console.error('error',e);

                    singleton.hideGetMessBtnLoading();
                    singleton.reloadRandCode();
                    $submitErroInfo.text('服务器异常,请稍后再试');
                    $submitBox.css('margin-top', '10px');
                });
        },

        bindComponentEvent : function(){
            let $stepContainer = this.$stepContainer;
            let that = this;
            $formBox = $stepContainer.find('.form-phone');
            $phone = $stepContainer.find(".phone");//手机号码
            $phoneCode = $stepContainer.find('.phoneCode');//手机验证码
            $randCode = $stepContainer.find('.randCode');//图形验证码
            $countDown = $stepContainer.find('.count-down-wrap');//发送验证码按钮
            $rankCodeWrap = $stepContainer.find(".rank-code-wrap");
            $mobilePhoneCon = $stepContainer.find(".mobile-phone-con");
            $phoneCodeCon = $stepContainer.find(".phone-code-con");
            $password = $stepContainer.find(".password");//密码
            $passwordCon = $stepContainer.find(".password-con");
            $codeImage = $stepContainer.find(".reg-rand-image");
            $agree = $stepContainer.find(".agree");
            $registerAgreeCon = $stepContainer.find('.register-agree-con');
            $submitErroInfo = $stepContainer.find(".submit-error-info");
            $submitBox = $stepContainer.find(".submit-box");
            $submitButton = $stepContainer.find(".submit-btn")

            // 手机号每隔一定位数加空格
            $phone.on('input',function(){
                let val = $(this).val() || '';
                val = that.mobileAddSpace(val)
                $(this).val(val);
            })

            this.inputFocus = function(){
                var timer = setTimeout(function(){
                    $phone.focus();
                    clearTimeout(timer);
                },0)
            }
            eventCenter.on('inputFocus', this.inputFocus)

            this.sendPhoneCode();

            this.validate();

            this.registerSubmit();

            //该请求在cms编辑器中会报错，所以改为正式访问才需要请求
            if ( this.isProductionMode() ){
                this._riskInit();
            }

            $('body').append($('.lp-detail-modal-main'));

        },

        componentWillUnmount : function(){
            this.$content = null;
            eventCenter.off('inputFocus', this.inputFocus)
        },

        renderStep1 : function( ){

            let type =  this.data.type;
            let inviteCode = this.data.inviteCode;
            let intention = this.data.intention;
            let submitText = this.data.submitText;
            let $background = this.data.btnBgColor;
            let $color = this.data.btnTextColor;

            let html = `<div class="form-phone">
                            <div class="lp-register-new-con">
                                <form class=" rui-form" autocomplete="off">
                                    <div class="mobile-phone-con register-item-con rui-form-text-container">
                                        <div class="rui-input-wrap">
                                            <input style="display:none" type="text" name="fake-phone-input"/>
                                            <input autocomplete="off" type="text" name="username" value="" _id="phone" class="rui-form-input phone" placeholder="输入手机号码">
                                        </div>
                                        <div class="rui-form-error-info"></div>
                                    </div>
                        `;

            html += `
                                <div class="register-item-con rank-code-wrap fn-clear" >
                                    <div class="rand-code-con  rui-form-text-container">
                                        <div class="rui-input-wrap">
                                            <input autocomplete="off" type="text" name="randCode" value="" _id="randCode" class="rui-form-input randCode" placeholder="输入图形验证码">
                                        </div>
                                    </div>
                                    <div class="rui-form-error-info"></div>
                                    <span class="code-image-con rui-phone-code-image-con img-clickable">
                                        <span class="code-image-wrap"><img class="reg-rand-image" align="absmiddle" src="/passport/index/captcha" name="randImage" alt="验证码" /></span>
                                    </span>
                                </div>
            `;

            html += `
                                    <div class="register-item-con phone-code-input fn-clear" >
                                         <div class="phone-code-con rui-form-text-container">
                                              <div class="rui-input-wrap">
                                                   <input autocomplete="off" type="text" name="mobileCode" _id="phoneCode" value="" class="rui-form-input phoneCode" placeholder="输入验证码"/>
                                              </div>
                                            <div class="rui-form-error-info"></div>
                                         </div>
                                         <div class="count-down-wrap phone-code-pass j-btn-orange" style="background:${$background};color:${$color};">
                                             <span class="btn-submit-word">获取验证码</span>
                                             <img class="btn-submit-loading" src="//www.renrendai.com/cms/5864b0d6a24d131067ef7956/recharge/loading.gif" alt="loading">
                                         </div>
                                    </div>
                                    <div class="password-con register-item-con rui-form-text-container">
                                         <div class="rui-input-wrap">
                                              <input style="display:none" type="password" name="fake-password-input"/>
                                              <input autocomplete="new-password" type="password" name="password" _id="password" value="" class="rui-form-input password" placeholder="输入登录密码"/>
                                         </div>
                                         <div class="rui-form-error-info"></div>
                                    </div>
                                    <input type="hidden" name="lpjumptoreg" value="" />
                                    <input type="hidden" name="type" value="${type}" />
                                    <input type="hidden" name="intention" value="${intention}"/>
                                    <input type="hidden" name="promotion" />
                                    <input type="hidden" name="inviteCode" value="${inviteCode}"/>
                                    <input type="hidden" name="userid" value=""  />
                                    <input type="hidden" name="extra" value="" />
                                    <div class="submit-error-info"></div>
                                    <div class="submit-box j-btn-block j-border-radius j-btn-orange">
                                        <input type="button" class="submit-btn j-btn j-btn-block j-border-radius j-btn-orange" style="background:${$background};color:${$color};" value="${submitText}"/>
                                        <img class="btn-submit-loading" src="//www.renrendai.com/cms/5864b0d6a24d131067ef7956/recharge/loading.gif" alt="loading">
                                    </div>
                                    <div class="register-item-con agreement-wrap">
                                    <div class="register-agree">
                                        注册即表明您已阅读并同意
                                        <a href="/agreement/contract/currency/name/user.rrd_reg" target="_blank">《人人贷注册服务协议》</a><a href="/agreement/contract/currency/name/user.rrd_privacy" target="_blank">《人人贷隐私权政策》</a>
                                    </div> 
                                    <div class="rui-form-error-info"></div>
                                   </div>
                                </form>
                            </div>
                        </div>`;
            let $remain = $(html);
            this.$step1.append( $remain );
        },

        //重新发送手机验证的倒计时
        resetCountdown : function(){
            let singleton = this;
            clearInterval( timer );

            remainSeconds = SECONDS;

            $countDown.find(".btn-submit-word").text( '重新发送(' + remainSeconds + ')' );

            $countDown.addClass("btn-disable").removeClass("j-btn-orange");

            function update(){
                remainSeconds--;
                if( remainSeconds < 1 ){
                    $countDown.find(".btn-submit-word").text('重新发送');
                    $countDown.removeClass("btn-disable");
                }else{
                    $countDown.find(".btn-submit-word").text( '重新发送(' + remainSeconds + ')' );
                }
            }

            timer = setInterval( update, 1000 );
        },

        setCodeMessage : function( msg ){
            $submitErroInfo.text(msg);
            $submitBox.css('margin-top', '10px');
        },

        isMobile: function () {
            let singleton = this;
            var mobileNum = this.spaceStrChangeMobile($phone.val());
            var isMobileOk = false;

            if(mobileNum.length == 0){

            }else{
                var isMobile = RRDValidator.validate.isMobile(mobileNum);
                if(!isMobile){
                    mess = "请输入正确手机号";
                    singleton.messageTips($mobilePhoneCon,mess);
                }else{
                    singleton.messageTipsHide($mobilePhoneCon);
                    isMobileOk = true;
                }
            }
            return isMobileOk;
        },

        //图形验证码校验
        isRankCode : function(){
            let singleton = this;

            var isRankOk = false;

            $rankCodeShow = $(".rank-code-wrap:visible");

            if($rankCodeShow.length > 0){

                var randCode = $randCode.val() || "";

                if(randCode.length == 0){

                }else if(randCode.length == 4){
                    singleton.messageTipsHide($rankCodeWrap);
                    isRankOk = true;
                }else{
                    mess = "请输入4位验证码";
                    singleton.messageTips($rankCodeWrap,mess);
                }

            }else{
                isRankOk = true;
            }

            return isRankOk;
        },

        checkPassword : function (password) {
            let tmp = [];
            if(password.length<8 || password.length>16){
                return false;
            }
            for(let i=0;i<password.length;i++){
                let result = this.passReg(password.charAt(i));
                if(!result){
                    return false;
                }else{
                    if(tmp.join('').indexOf(result)==-1){
                        tmp.push(result);
                    }
                }
            }
            return tmp.length>=2;
        },

        passReg : function (letter) {
            if(/[A-Za-z]/.test(letter)){
                return 1;
            }
            if(/[0-9]/.test(letter)){
                return 2;
            }
            if(/[!@#$%^&*._]/.test(letter)){
                return 3;
            }
            return false;
        },

        //密码校验
        isPassWord: function () {
            let singleton = this;

            var isPassOk = false;
            var v = $password.val();

            var isPassWord = this.checkPassword(v);
            //var isPassWord = (/^[\@A-Za-z0-9\!\#\$\%\^\&\*\.\~]{1,}$/).test(v);
            //var isPassNotAllNum = !((/^\d{1,}$/).test(v));
            //var isPassNotRepeat = !(new RegExp(/^(.)\1+$/).test(v));

            if(v.length == 0){

            }else if(!isPassWord ){
                mess = "8-16位数字、字母或符号组合";
                singleton.messageTips($passwordCon,mess);
            } else {
                singleton.messageTipsHide($passwordCon);
                isPassOk = true;
            }

            return isPassOk;
        },

        //短信验证码校验
        isPhoneCode: function(){
            let singleton = this;

            var isPhoneCodeOk = false;
            var phoneC = $phoneCode.val();

            if(phoneC.length == 0){

            }else{
                singleton.messageTipsHide($phoneCodeCon);
                isPhoneCodeOk = true;
            }

            return isPhoneCodeOk;
        },

        isAgree : function(){
            // let singleton = this;

            // var isAgreeOk = false;
            // var agreeChecked = singleton.$stepContainer.find(".agree")[0].checked;

            // if(agreeChecked){
            //     $registerAgreeCon.addClass("rui-form-checkbox-checked").removeClass('rui-form-checkbox-error validate-error-con');
            //     singleton.messageTipsHide($registerAgreeCon);
            //     isAgreeOk = true;
            // }else{
            //     $registerAgreeCon.addClass("rui-form-checkbox-error validate-error-con").removeClass('rui-form-checkbox-checked');
            //     singleton.messageTips($registerAgreeCon,"请同意我们的条款");
            // }

            return true;
        },

        validate : function() {
            let singleton = this;
            let $stepContainer = this.$stepContainer;
            $(document).on({
                blur: function (e) {

                    var id = $(this).attr("_id");

                    switch (id) {
                        case 'phone':
                            if (singleton.isMobile()) {
                                //不允许直接检测手机号是否已注册，会暴露已注册的手机号，被刷
                            }
                            break;

                        case 'randCode':
                            singleton.isRankCode();
                            break;

                        case 'phoneCode':
                            singleton.isPhoneCode();
                            break;

                        case 'password':
                            singleton.isPassWord();
                            break;
                    }

                },
            }, '.phone,.randCode,.phoneCode,.password');

            $password.on({
                focus:function () {
                    mess = "8-16位数字、字母或符号组合";
                    singleton.messageTips($passwordCon, mess);
                },
                keyup:function () {
                    singleton.isPassWord();
                }
            });

            //刷新验证码
            $codeImage.on("click",function(){
                singleton.reloadRandCode();
            });


            //同意条款
            // $(".checkbox-holder").on("click",function(){

            //     var agreeChecked = $stepContainer.find(".agree")[0];
            //     agreeChecked.checked = !agreeChecked.checked;
            //     singleton.isAgree();

            // });
        },

        reloadRandCode: function(){
            let time = new Date().getTime();
            $('.reg-rand-image').attr('src','/passport/index/captcha?time='+ time);
        },

        messageTips : function(id,mess){

            id.find(".rui-input-wrap").css("border-color","#ee7565");
            id.addClass(" rui-form-text-error validate-error-con");
            id.find(".rui-form-error-info").show().text(mess);
        },

        messageTipsHide : function(id){

            id.find(".rui-input-wrap").css("border-color","#e6e6e6");
            id.removeClass(" rui-form-text-error validate-error-con");
            id.find(".rui-form-error-info").hide();
        },

        zhugeFail : function(mess){
            statistic.eventRaw({
                pageKey : tplConf.pageKey,
                eventId : 'mainFormRegisterFail',
                extra : {
                    '失败原因' : mess
                }
            });
        },

        //极验验证 初始化
        initGt(geetestData){
            // 调用 initGeetest 进行初始化
            // 参数1：配置参数
            // 参数2：回调，回调的第一个参数验证码对象，之后可以使用它调用相应的接口
            initGeetest({
                // 以下 4 个配置参数为必须，不能缺少
                gt: geetestData.gt,
                challenge: geetestData.challenge,
                offline: !geetestData.success, // 表示用户后台检测极验服务器是否宕机
                new_captcha: geetestData.new_captcha, // 用于宕机时表示是新验证码的宕机

                product: "bind", // 产品形式，包括：float，popup
                width: "300px",
                pure : 1,//1 表示纯净无loading  0表示有loading
                // 更多配置参数说明请参见：http://docs.geetest.com/install/client/web-front/
            }, this.handler.bind(this));
        },

        //极验验证 初始化 回调函数
        handler(captchaObj){

            this.captchaObj = captchaObj;

            let that = this;
            captchaObj.onReady(function () {
            })
            captchaObj.onNextReady(function(){
            })
            captchaObj.onClose(function(){
                that.hideGetMessBtnLoading();
            })
            captchaObj.onError(function(){
                that.hideGetMessBtnLoading();
                captchaObj.reset();
            })
            captchaObj.onSuccess(function () {
                let result = captchaObj.getValidate();
                if (!result) {
                    let mess = '请完成验证';
                    that.messageTips($mobilePhoneCon,mess);
                    return ;
                }

                let channel = (window.tplConf._isWeCom == 'true') ? 'WE' : 'RRD';
                let verifData = {
                    channel : channel,
                    mobile : that.spaceStrChangeMobile($phone.val()),
                    origin : 'LP-PC',
                    geetest_challenge: result.geetest_challenge,
                    geetest_validate: result.geetest_validate,
                    geetest_seccode: result.geetest_seccode,
                }

                that.sendGeetestVerification(verifData);

            });
        },
        //有极验验证时候发送的请求
        sendGeetestVerification(verifData){
            let that = this;
            if($countDown.hasClass('is_send')) return;

            registerService.sendRegisterSms(verifData).then(function(res){
                that.hideGetMessBtnLoading();
                let out = res.data;
                if( res.requestStatus === registerService.STATUS.SUCCESS ){
                    if(out.status == 0){
                        //处理极验完成后的倒计时
                        that.resetCountdown();
                        that.sendTimes++;
                        return;
                    }else{
                        let mess = out.message;
                        that.messageTips($mobilePhoneCon,mess);
                    }
                }
            }).catch(function(){
                that.hideGetMessBtnLoading();
                let mess = '服务器异常,请稍后再试';
                that.messageTips($mobilePhoneCon,mess);
            });

            statistic.eventRaw({
                eventId : 'PC_lp_click_get_message'
            });
        },

        _riskInit(){
            //风险提示初始化
            let that = this;
            registerService.riskSwitchStatus().then( ( result ) => {
                let rsp = result.data;
                if( rsp.status === 0 ){
                    that.riskSwitchStatus = rsp.data.display;
                }else {
                    alert(result.message || '网络异常，稍后再试')
                }

            })
                .catch( (e) => {
                    alert(e.message || '网络异常，稍后再试');
                });
            //获取风险提示弹窗内容
            registerService.riskContentStatus().then( ( result ) => {
                let rsp = result.data;
                if( rsp.status === 0 ){
                    that.riskDetail = rsp.data;
                }else {
                    alert(result.message || '网络异常，稍后再试')
                }

            })
                .catch( (e) => {
                    alert(e.message || '网络异常，稍后再试');
                });

            $('.J-detail-close','#risk-modal').on('click',function () {
                $('.lp-detail-modal-main').hide();
            });
            $('.J-detail-submit','#risk-modal').on('click',function () {
                $('.lp-detail-modal-main').hide();
                //区分极验和普通验证码的提交接口
                if( that.verifyType === 'geetest' ) {
                    that._submitRigisterByGeetest(__registerOutParamsByGeetest);
                }else{
                    that._submitRigister(__registerOutParams);
                }
            });
        },

        _submitRigisterByGeetest(finalPostData){
            //极验提交表单
            let singleton = this;
            let success_url = singleton.data.success_url;
            registerService.rrdRegister(finalPostData).then(function(res){
                singleton.hideSubmitBtnLoading();
                if( res.requestStatus === registerService.STATUS.SUCCESS ){

                    let out = res.data;

                    //3310手机验证码类的,3320手机号类的,3330密码类的
                    if( out.status === 0 ){

                        //处理配置中的callback
                        if(singleton.data.hasCallBack){
                            try{
                                if(typeof callBackPbFn === 'function'){
                                    callBackPbFn();
                                }
                            }catch (e){}
                        }

                        //发送统计代码
                        statistic.eventRaw({
                            eventId : 'PC_lp_register_success',
                            extra:{
                                'url' : location.href
                            },
                            callback: function(){
                                //验证码正确,跳转到 注册成功页
                                if(success_url){
                                    location.href = success_url;
                                }else if(out.data.jumpURL){
                                    location.href = out.data.jumpURL;
                                }else {
                                    location.href = '/user/setting/openAccount';
                                }
                            }
                        });
                    }else if( out.status === 3310 ){
                        singleton.zhugeFail(out.message);
                        singleton.messageTips($phoneCodeCon,out.message);

                    }else if( out.status === 3320 ){
                        singleton.zhugeFail(out.message);
                        singleton.messageTips($mobilePhoneCon,out.message);

                    }else if( out.status === 3330 ){
                        singleton.zhugeFail(out.message);
                        singleton.messageTips($passwordCon,out.message);
                    }else{
                        singleton.zhugeFail(out.message);
                        singleton.setCodeMessage(out.message);
                    }
                }else{
                    //出错
                    let msg = res.data.message || '请求后端服务出错, 请稍后再试';
                    singleton.zhugeFail(msg);
                    singleton.messageTips($mobilePhoneCon,msg);
                }
            }).catch(function(event){
                singleton.hideSubmitBtnLoading();
                singleton.zhugeFail(event.message);
                singleton.messageTips($mobilePhoneCon,event.message);
            });
        },

        _submitRigister(dataForm){
            //图验提交表单
            let singleton = this;
            let success_url = singleton.data.success_url;
            registerService.rrdRegister(dataForm)
                .then((res)=>{
                    singleton.hideSubmitBtnLoading();
                    if( res.requestStatus === registerService.STATUS.SUCCESS ){
                        var out;
                        if( typeof res === 'string' ){
                            try{
                                out = JSON.parse( res).data;
                            }catch(e){
                                out = {
                                    status : -1,
                                    message : '解析结果出错'
                                };
                            }
                        }else{
                            out = res.data;
                        }

                        //3310手机验证码类的,3320手机号类的,3330密码类的
                        if( out.status === 0 ){

                            if(singleton.data.hasCallBack){
                                try{
                                    if(typeof callBackPbFn === 'function'){
                                        callBackPbFn();
                                    }
                                }catch (e){}
                            }

                            if(success_url){
                                location.href = success_url;
                            }else if(out.data.jumpURL){
                                location.href = out.data.jumpURL;
                            }else {
                                location.href = '/user/setting/openAccount';
                            }

                        }else if( out.status === 3310 ){
                            singleton.zhugeFail(out.message);
                            singleton.messageTips($phoneCodeCon,out.message);

                        }else if( out.status === 3320 ){
                            singleton.zhugeFail(out.message);
                            singleton.messageTips($mobilePhoneCon,out.message);

                        }else if( out.status === 3330 ){
                            singleton.zhugeFail(out.message);
                            singleton.messageTips($passwordCon,out.message);
                        }else{
                            singleton.zhugeFail(out.message);
                            singleton.setCodeMessage(out.message);
                        }
                    }
                })
                .catch( (e) => {
                    singleton.hideSubmitBtnLoading();
                    singleton.zhugeFail(out.message);
                    singleton.setCodeMessage('服务器异常,请稍后再试');
                });
        }
    }
);


module.exports = registerItemList;