/**
 * LP页面底部的footer区域
 * Created by Liu Cong on 2017/6/24.
 */


const glpbCommon = require('glpb-components-common');

const DataManager = require('../../common/data-manager/data-manager.js');


require('./rrd-lp-footer.scss');

const BaseComponent = glpbCommon.BaseComponent;

const $ = BaseComponent.$;

const utils = BaseComponent.utils;


const tpl = `<div><div class="glpb-footer" style="background: #f6f8fc
"></div></div>`;


const LandingPageHeader = BaseComponent.extend(
    {
        componentName : 'glpb_rrd_com_pc_lp_footer',
        componentNameZh : 'PC-LP-footer',
        componentCategory : BaseComponent.CATEGORY.UI,
        platform : BaseComponent.PLATFORM.PC,
        canBeChildOfComponentName : function(){
            return true;
        }
    },
    {
        getDefaultStyle : function(){
            return {};
        },

        getDefaultData : function(){
            return {};
        },

        init : function(){
            //当前Ajax请求的ID
            this.querySign = null;
            //是否已经绑定了组件自定义事件
            this.eventBinded = false;
        },

        render : function(){
            let currentComponentId = this.componentId;
            let data = this.data;

            let cssClass = this.getBaseCssClass() + '  ';
            let cssStyle = this.translateStyle( this.style );
            let $el = $(tpl).addClass( cssClass ).css( cssStyle );
            let $content = $('.glpb-footer', $el);

            this.$el = $el;
            this.$content = $content;

            let html = `<div class="rrd-lp-footer">
                            <div class="footer-box">
                                <p>© 2017 人人贷商务顾问(北京)有限公司 All rights reserved     京ICP证 100953号 京公网安备 11010802021944 京ICP备12025643号-1     市场有风险 投资需谨慎 </p>
                                <p>客服热线：95770</p>
                            </div>
                        </div>`;

            $content.html( html );

        },

        bindComponentEvent : function(){
            let that = this;
            let data = this.data || {};
        },

        setData : function( data ){
            this.data = $.extend( {}, this.data, data );
            data = this.data;

        },

        componentWillUnmount : function(){
        }
    }
);


module.exports = LandingPageHeader;

