/**
 * U计划 6个产品卡 组件
 * Created by daifei on 2017/11/21
 */

const moment = require('moment');

const numeral = require('numeral');

const glpbCommon = require('glpb-components-common');

const serviceFactory = require('../../service/service-factory.js');

require('./uplan-product-6-card.scss');

const BaseComponent = glpbCommon.BaseComponent;

const $ = BaseComponent.$;

const utils = BaseComponent.utils;

const uPlanService = serviceFactory.getService('uPlan');

const tpl = `<div><div class="glpb-rrd-finance-plan"></div></div>`;

const editorPlaceHolderImage = '//www.we.com/cms/5864b0d6a24d131067ef7956/spread/5.png';

const xianImg = '//www.we.com/cms/5864b0d6a24d131067ef7956/spread/uplan_xian.png';
const RRDUPlanItem = BaseComponent.extend(
    {
        componentName : 'glpb_uplan_product_card_item',
        componentNameZh : 'U计划1月3月6月12月24月36月',
        componentCategory : BaseComponent.CATEGORY.UI,
        platform : BaseComponent.PLATFORM.PC,
        canBeChildOfComponentName : function(){
            return true;
        }
    },
    {
        getDefaultStyle : function(){
            return {
                background : {
                    backgroundColor : 'none'
                },
                width : '1080px',
                padding : '0',
                margin : '16px auto'
            };
        },

        getDefaultData : function(){
            return {
                "productNameStyle_$$comment": "U计划12个月 产品的名字的样式如：color:red;font-size:12px",
                productNameStyle:"",
                "productCardStyle_$$comment":"U计划12个月 单个卡片的的样式 背景色 如：color:red;font-size:12px",
                productCardStyle : "",
                "prductBigRateStyle_$$comment":"产品利率的颜色字号样式 如：color:red;font-size:12px",
                prductBigRateStyle : '',
                "prductSmallRateStyle_$$comment":"产品加息利率的颜色字号样式 如：color:red;font-size:12px",
                prductSmallRateStyle : '',
                "prductDescTextStyle_$$comment":"U计划卡片扣费后年利率文字样式 如：color:red;font-size:12px",
                prductDescTextStyle : '',
                "productCardTagStyle_$$comment":"U计划卡片tag文字样式 如：color:red;font-size:12px",
                productCardTag : '',
                "joinButton_$$comment" : "立即加入按钮的样式 如：color:red;font-size:12px",
                joinButton : '',
                "rateTipText_$$comment" : "扣费后年利率 文案",
                rateTipText : "扣费后年利率",
            };
        },

        init : function(){
            //当前Ajax请求的ID
            this.querySign = null;
            //是否已经绑定了组件自定义事件
            this.eventBinded = false;
            //产品对应的详细数据
            this.productData = null;
        },

        render : function(){
            let cssClass = this.getBaseCssClass() + '  ';
            let cssStyle = this.translateStyle( this.style );
            let $el = $(tpl).addClass( cssClass ).css( cssStyle );
            let $content = $('.glpb-rrd-finance-plan', $el);

            this.$el = $el;
            this.$content = $content;

            if( ! this.isProductionMode() ){
                //编辑模式, 显示一个图片占位
                $(`<li><img class="editor-place-holder-img" src="${editorPlaceHolderImage}" title="U计划列表占位图片(非真实数据)" /></li>`).appendTo( $content );
            }
        },

        bindComponentEvent : function(){
            let that = this;

            if( this.isProductionMode() && ! this.eventBinded ){
                //正式环境才绑定事件, 并且Ajax请求U计划的具体数据

                this.querySign = utils.generateQuerySign();


                uPlanService.getIndexUplanProductCard( )
                    .then( ( reqResult ) => {
                        if( reqResult.requestStatus === uPlanService.STATUS.SUCCESS ){
                            let result = reqResult.data;

                            if( result.status === 0 ){
                                that.setListDetailData( result.data );
                                return;
                            }
                            return Promise.reject(new Error(result.message));
                        }
                        return Promise.reject( new Error('获取U享卡片定义产品数据异常!'));
                    })
                    .catch( (e) => {
                        alert(e.message);
                        that.hide();
                    });
            }
        },

        componentWillUnmount : function(){
            this.$content = null;
        },

        setListDetailData : function( list ){
            list = list || [];
            if( ! list || list.length < 1 ){
                return this.hide();
            }

            let html = `<div class="product-list-card"><ul>`;
            //只展示一条数据

            list.forEach((item, index)=>{
                html += this._renderUPlanItem( item );
            })
            html += `</ul></div>`;

            if( html ){
                this.$content.html( html );
            }else{
                this.hide();
            }
        },

        _renderUPlanItem : function( obj ){
            let getHost = utils.getTplConf();
            let hostName = getHost.we_renrendai_host;

            //let detailURL = `${hostName}/uplan/${obj.id}.html`;

            //加息的利率

            //颜色字体 样式
            let cmsData = this.data;
            let productNameStyle = cmsData.productNameStyle;
            let productCardStyle = cmsData.productCardStyle;
            let prductBigRateStyle = cmsData.prductBigRateStyle;
            let prductSmallRateStyle = cmsData.prductSmallRateStyle;
            let prductDescTextStyle = cmsData.prductDescTextStyle;
            let productCardTag = cmsData.productCardTag;
            let joinButton = cmsData.joinButton;
            let rateTipText = cmsData.rateTipText;

            //标签的样式
            let tag = obj.tag ? `<span class="new" style="${productCardTag}">${obj.tag}</span>`:'';
            //是否有加息
            let rateText = '';
            if(obj.extraInterestRate){
                rateText = `<span class="num"><i class="fu" style="${prductBigRateStyle}">${obj.baseInterestRate}</i><em style="${prductSmallRateStyle}">%</em><i class="dan" style="${prductSmallRateStyle}">+${obj.extraInterestRate}</i><em style="${prductSmallRateStyle}">%</em></span>`;
            }else{
                rateText = `<span class="num"><i class="fu" style="${prductBigRateStyle}">${obj.expectedYearRate}</i><em style="${prductSmallRateStyle}">%</em></span>`;
            }
            return `
                <li style="${productCardStyle}">
                    <p class="time">
                        <span class="month" style="${productNameStyle}"><em style="${productNameStyle}">U享-${obj.lockPeriod}个月</em></span>
                        <img src="${xianImg}" class="xian">
                    </p>
                    <p class="rate mtop">
                        
                         ${rateText}                        
                        <span class="nian" style="${prductDescTextStyle}">${rateTipText || '扣费后年利率'}</span>
                        
                        ${tag}
                        
                        <span class="highest"></span>
                    </p>
                    <p class="name">
                        <a href="#lp-depository" style="${joinButton}">授权出借</a>
                    </p>
            
                </li>
            `;
        }
    }
);


module.exports = RRDUPlanItem;
