/**
 * 维护所有的service的工厂
 * Created by 王半仙 on 16/6/13.
 */





const passportService = require('./sub/passport-service');

const fundService = require('./sub/fund-service.js');
const exchangeService = require('./sub/exchange-service.js');
const userService = require('./sub/user-service.js');
const registerService = require('./sub/register-service.js');
const uPlanService = require('./sub/uPlan-service.js');
const lpService = require('./sub/lp-service.js');

let serviceMap = {
    passport : passportService,
    user : userService,
    fund : fundService,
    exchange : exchangeService,
    register: registerService,
    uPlan : uPlanService,
    lp : lpService

};

let singleton = {

    getService : function(name){
        return serviceMap[name];
    }

};



module.exports = singleton;